#!/bin/bash -
#
# Operacje cyberbezpieczeństwa w bashu
# checkemail.sh
#
# Opis:
# Sprawdza, czy adres e-mail znajduje się
# w bazie danych Have I Been Pwned? 
#
# Użycie: ./checkemail.sh [<email>]
#   <email> Adres e-mail, których trzeba zweryfikować; domyślny: wczytany ze strumienia stdin
#

if (( "$#" == 0 ))	#<1>
then
	printf 'Wpisz adres e-mail: '
	read emailin
else
	emailin="$1"
fi

pwned=$(curl -s "https://haveibeenpwned.com/api/v2/breachedaccount/$emailin")	#<2>

if [ "$pwned" == "" ]
then
	exit 1
else
	echo 'Konto wyciekło w następujących włamaniach:'
	echo "$pwned" | grep -Po '"Name":".*?"' | cut -d':' -f2 | tr -d '\"'	#<3>
	exit 0
fi

